function ajaxCall()
{
    $(document).ready(function() {

        $('#bt').click(function () {
            $('#books').empty();       // Clear the DIV.

            $.ajax({
                type: 'GET',
                url: 'sprawdziany/testy.xml',           // The file path.
                dataType: 'xml',
                success: function(xml) {
                    $(xml).find('List').each(function() {

                        // Append new data to the DIV element.
                        $('#books').append(
                            '<div>' +
                                '<div><b>Nazwa sprawdzianu: </b>' +
                                    $(this).find('Sprawdzian').text() + '</div> ' +
                                '<div><b>Godzina i data: </b>' +
                                    $(this).find('Godz').text() + '</div> ' +
                                '<div><b>Miejsce: </b>' +
                                    $(this).find('Klasa').text() + '</div> ' +
                            '</div>');
                    });
                }
            });
        });
    });
}

